# distbuild/__init__.py -- library for Morph's distributed build plugin
#
# Copyright (C) 2012, 2014-2015  Codethink Limited
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.


from stringbuffer import StringBuffer
from sm import StateMachine
from eventsrc import EventSource
from socketsrc import (SocketError, NewConnection, ListeningSocketEventSource,
                       SocketReadable, SocketWriteable, SocketEventSource,
                       set_nonblocking)
from sockbuf import (SocketBufferNewData, SocketBufferEof, 
                     SocketBufferClosed, SocketBuffer)
from mainloop import MainLoop
from sockserv import ListenServer
from jm import JsonMachine, JsonNewMessage, JsonEof, JsonError

from artifact_reference import (encode_artifact,
                                encode_artifact_reference,
                                decode_artifact_reference)
from idgen import IdentifierGenerator
from route_map import RouteMap
from timer_event_source import TimerEventSource, Timer
from proxy_event_source import ProxyEventSource
from json_router import JsonRouter
from helper_router import (HelperRouter, HelperRequest, HelperOutput, 
                           HelperResult)
from initiator_connection import (InitiatorConnection, InitiatorDisconnect,
                                  CancelRequest)
from connection_machine import (ConnectionMachine, InitiatorConnectionMachine,
                                Reconnect, StopConnecting)
from worker_build_scheduler import (WorkerBuildQueuer, 
                                    WorkerConnection, 
                                    WorkerBuildRequest,
                                    WorkerCancelPending,
                                    WorkerBuildOutput,
                                    WorkerBuildCaching,
                                    WorkerBuildStepAlreadyStarted,
                                    WorkerBuildWaiting,
                                    WorkerBuildFinished,
                                    WorkerBuildFailed,
                                    WorkerBuildStepStarted)

from build_controller import (BuildController, BuildFailed, BuildProgress,
                              BuildStepStarted, BuildStepAlreadyStarted,
                              BuildOutput, BuildStepFinished, BuildStepFailed,
                              BuildFinished, BuildCancel, BuildStarted,
                              GraphingStarted, GraphingFinished, CacheState,
                              build_step_name, map_build_graph)
from initiator import (Initiator, InitiatorStart, InitiatorCommand)
from protocol import message

from crashpoint import (crash_point, add_crash_condition, add_crash_conditions,
                        clear_crash_conditions)

from distbuild_socket import create_socket

from subprocess_eventsrc import (FileReadable, FileWriteable,
                                 SubprocessEventSource)

__all__ = locals()
